| VTK 9.0.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkPerlinNoise Class Reference

an implicit function that implements Perlin noise More...

`#include <vtkPerlinNoise.h>`

Inheritance diagram for vtkPerlinNoise:
[legend]
Collaboration diagram for vtkPerlinNoise:
[legend]

## Public Types
typedef vtkImplicitFunction | Superclass
Public Types inherited from vtkImplicitFunction
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkPerlinNoise * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
double | EvaluateFunction (double x[3]) override
| Evaluate function at position x-y-z and return value. More...
void | EvaluateGradient (double x[3], double n[3]) override
| Evaluate PerlinNoise gradient. More...
virtual void | SetFrequency (double, double, double)
| Set/get the frequency, or physical scale, of the noise function (higher is finer scale). More...
virtual void | SetFrequency (double[3])
virtual double * | GetFrequency ()
virtual void | GetFrequency (double data[3])
virtual void | SetPhase (double, double, double)
| Set/get the phase of the noise function. More...
virtual void | SetPhase (double[3])
virtual double * | GetPhase ()
virtual void | GetPhase (double data[3])
virtual void | SetAmplitude (double)
| Set/get the amplitude of the noise function. More...
virtual double | GetAmplitude ()
virtual double | EvaluateFunction (double x[3])=0
| Evaluate PerlinNoise function. More...
virtual void | EvaluateFunction (vtkDataArray *input, vtkDataArray *output)
| Evaluate PerlinNoise function. More...
virtual double | EvaluateFunction (double x, double y, double z)
| Evaluate PerlinNoise function. More...
Public Member Functions inherited from vtkImplicitFunction
vtkImplicitFunction * | NewInstance () const
vtkMTimeType | GetMTime () override
| Overload standard modified time function. More...
virtual void | FunctionValue (vtkDataArray *input, vtkDataArray *output)
| Evaluate function at position x-y-z and return value. More...
double | FunctionValue (const double x[3])
double | FunctionValue (double x, double y, double z)
void | FunctionGradient (const double x[3], double g[3])
| Evaluate function gradient at position x-y-z and pass back vector. More...
double * | FunctionGradient (const double x[3])
double * | FunctionGradient (double x, double y, double z)
virtual void | SetTransform (vtkAbstractTransform *)
| Set/Get a transformation to apply to input points before executing the implicit function. More...
virtual void | SetTransform (const double elements[16])
virtual vtkAbstractTransform * | GetTransform ()
virtual void | EvaluateFunction (vtkDataArray *input, vtkDataArray *output)
virtual double | EvaluateFunction (double x, double y, double z)
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
vtkCommand * | GetCommand (unsigned long tag)
void | RemoveObserver (vtkCommand *)
void | RemoveObservers (unsigned long event, vtkCommand *)
void | RemoveObservers (const char *event, vtkCommand *)
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
int | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
int | InvokeEvent (const char *event, void *callData)
int | InvokeEvent (unsigned long event)
int | InvokeEvent (const char *event)
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
void | PrintRevisions (ostream &)
| Legacy. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkPerlinNoise * | SafeDownCast (vtkObjectBase *o)
static vtkPerlinNoise * | New ()
| Instantiate the class. More...
Static Public Member Functions inherited from vtkImplicitFunction
static vtkTypeBool | IsTypeOf (const char *type)
static vtkImplicitFunction * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (int val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
static void | GlobalWarningDisplayOff ()
static int | GetGlobalWarningDisplay ()
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkPerlinNoise ()
| ~vtkPerlinNoise () override
Protected Member Functions inherited from vtkImplicitFunction
| vtkImplicitFunction ()
| ~vtkImplicitFunction () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | CollectRevisions (ostream &)
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
double | Frequency [3]
double | Phase [3]
double | Amplitude
Protected Attributes inherited from vtkImplicitFunction
vtkAbstractTransform * | Transform
double | ReturnValue [3]
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

an implicit function that implements Perlin noise

vtkPerlinNoise computes a Perlin noise field as an implicit function. vtkPerlinNoise is a concrete implementation of vtkImplicitFunction. Perlin noise, originally described by Ken Perlin, is a non-periodic and continuous noise function useful for modeling real-world objects.

The amplitude and frequency of the noise pattern are adjustable. This implementation of Perlin noise is derived closely from Greg Ward's version in Graphics Gems II.

See also
  vtkImplicitFunction

Definition at line 38 of file vtkPerlinNoise.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkImplicitFunction vtkPerlinNoise::Superclass

Definition at line 41 of file vtkPerlinNoise.h.

## Constructor & Destructor Documentation

## ◆ vtkPerlinNoise()

vtkPerlinNoise::vtkPerlinNoise | ( |  | ) |
| protected

## ◆ ~vtkPerlinNoise()

vtkPerlinNoise::~vtkPerlinNoise | ( |  | ) |
| inline override protected

Definition at line 97 of file vtkPerlinNoise.h.

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkPerlinNoise::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkPerlinNoise::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkImplicitFunction.

## ◆ SafeDownCast()

static vtkPerlinNoise* vtkPerlinNoise::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkPerlinNoise::NewInstanceInternal | ( |  | ) | const
| protected virtual

Reimplemented from vtkImplicitFunction.

## ◆ NewInstance()

vtkPerlinNoise* vtkPerlinNoise::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkPerlinNoise::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| override virtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkImplicitFunction.

## ◆ New()

static vtkPerlinNoise* vtkPerlinNoise::New | ( |  | ) |
| static

Instantiate the class.

## ◆ EvaluateFunction() [1/4]

double vtkPerlinNoise::EvaluateFunction | ( | double | x[3] | ) |
| override virtual

Evaluate function at position x-y-z and return value.

You should generally not call this method directly, you should use FunctionValue() instead. This method must be implemented by any derived class.

Implements vtkImplicitFunction.

## ◆ EvaluateGradient()

void vtkPerlinNoise::EvaluateGradient | ( | double | x[3],
|  | double | n[3]
| ) |  |
| override virtual

Evaluate PerlinNoise gradient.

Currently, the method returns a 0 gradient.

Implements vtkImplicitFunction.

## ◆ SetFrequency() [1/2]

virtual void vtkPerlinNoise::SetFrequency | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/get the frequency, or physical scale, of the noise function (higher is finer scale).

The frequency can be adjusted per axis, or the same for all axes.

## ◆ SetFrequency() [2/2]

virtual void vtkPerlinNoise::SetFrequency | ( | double | [3] | ) |
| virtual

## ◆ GetFrequency() [1/2]

virtual double* vtkPerlinNoise::GetFrequency | ( |  | ) |
| virtual

## ◆ GetFrequency() [2/2]

virtual void vtkPerlinNoise::GetFrequency | ( | double | data[3] | ) |
| virtual

## ◆ SetPhase() [1/2]

virtual void vtkPerlinNoise::SetPhase | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/get the phase of the noise function.

This parameter can be used to shift the noise function within space (perhaps to avoid a beat with a noise pattern at another scale). Phase tends to repeat about every unit, so a phase of 0.5 is a half-cycle shift.

## ◆ SetPhase() [2/2]

virtual void vtkPerlinNoise::SetPhase | ( | double | [3] | ) |
| virtual

## ◆ GetPhase() [1/2]

virtual double* vtkPerlinNoise::GetPhase | ( |  | ) |
| virtual

## ◆ GetPhase() [2/2]

virtual void vtkPerlinNoise::GetPhase | ( | double | data[3] | ) |
| virtual

## ◆ SetAmplitude()

virtual void vtkPerlinNoise::SetAmplitude | ( | double |  | ) |
| virtual

Set/get the amplitude of the noise function.

Amplitude can be negative. The noise function varies randomly between -|Amplitude| and |Amplitude|. Therefore the range of values is 2*|Amplitude| large. The initial amplitude is 1.

## ◆ GetAmplitude()

virtual double vtkPerlinNoise::GetAmplitude | ( |  | ) |
| virtual

## ◆ EvaluateFunction() [2/4]

virtual double vtkImplicitFunction::EvaluateFunction

Evaluate PerlinNoise function.

## ◆ EvaluateFunction() [3/4]

virtual void vtkImplicitFunction::EvaluateFunction

Evaluate PerlinNoise function.

## ◆ EvaluateFunction() [4/4]

virtual double vtkImplicitFunction::EvaluateFunction
| inline

Evaluate PerlinNoise function.

Definition at line 123 of file vtkImplicitFunction.h.

## Member Data Documentation

## ◆ Frequency

double vtkPerlinNoise::Frequency[3]
| protected

Definition at line 99 of file vtkPerlinNoise.h.

## ◆ Phase

double vtkPerlinNoise::Phase[3]
| protected

Definition at line 100 of file vtkPerlinNoise.h.

## ◆ Amplitude

double vtkPerlinNoise::Amplitude
| protected

Definition at line 101 of file vtkPerlinNoise.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkPerlinNoise.h